#!/tvbin/tivosh
#SetMfsHostname.tcl Copyright 2006 AlphaWolf_HK
#Neither this file nor any derivative may be distributed anywhere outside of
#the forums located at www.dealdatabase.com.
#
#This script configures the host name value in MFS to the first name passed as
#an argument, and also sets that as the global host name setting with the
#hostname binary. If none is given, then the already set "hostname" value is
#used.
#

EnableTransactionHoldoff true

set db [dbopen]

set hostname [lindex $argv 0]

if { $hostname == "" } {
  set hostname [exec hostname]
} else {
  exec hostname $hostname
}

RetryTransaction {
  set objlisting [mfs scan /State/Network]
  set obj [lindex [lindex $objlisting 0] 0]
  set nobj [db $db openidconstruction $obj]
  set cobj [dbobj $nobj get IpParams]
  dbobj $cobj set AutoConfigHostId $hostname
  puts "MFS hostname set to \"$hostname\""
}

