#!/bin/bash
#Copyright 2004 AlphaWolf_HK, Original concept by cojonesdetoro
#Neither this file nor any derivative may be distributed anywhere outside of
#the forums located at www.dealdatabase.com.
#
#This script will run an sha1sum on an inputted password and compare it against
#a marker file in the root dir which is set by tivopasswd.sh. If the password
#matches, it launches bash. You can run this script instead of bash from your
#telnet daemon for some added security.
#
#(e.g. tnlited 23 /tivo-bin/tivologin.sh)
#

#If the password file doesn't exist then assume none has been set.
if [ ! -e /.tivopassword ]; then
    echo "No password file found, type \"tivopasswd.sh\" to set one."
    /bin/bash --login
    exit
fi

TRIES=0
while [ $TRIES -lt 3 ]; do
    echo -n "Password: "
    /bin/stty -echo
    read PASS
    /bin/stty echo
    echo ""

    echo $PASS | sha1sum -c /.tivopassword -s
    if [ $? == 0 ]; then
        clear
        /bin/bash --login
        exit
    else
        sleep 3
        echo "Invalid password."
    fi
    let TRIES=TRIES+1
done

echo "Too many failed attempts, bye."
exit -1
