#!/bin/bash
#Copyright 2004 AlphaWolf_HK
#Neither this file nor any derivative may be distributed anywhere outside of
#the forums located at www.dealdatabase.com.
#
#This script creates a password file in the root directory which contains an
#sha1sum based on a password you enter. This can provide basic security for
#your tivo from people within your home LAN. See 'tivologin.sh' for details.
#

echo "TivoPasswd by AlphaWolf_HK."

REMOUNT=0

function reMount () {
    if [ $REMOUNT == 1 ]; then
        mount -o remount,ro /
    fi
}

echo test | dd of=/remountrandomtestfile > /dev/null 2>&1
if [ $? == 1 ]; then
    mount -o remount,rw /
    declare REMOUNT=1
fi

rm -rf /remountrandomtestfile > /dev/null 2>&1

echo -n "Enter new password: "
/bin/stty -echo
read PASS
/bin/stty echo
echo ""

echo -n "Confirm new password: "
/bin/stty -echo
read PASS2
/bin/stty echo
echo ""

if [ "${PASS}" == "${PASS2}" ]; then
    echo $PASS | sha1sum > /.tivopassword
    reMount
    echo "New password set."
else
    echo "Passwords don't match."
    reMount
    exit -1
fi
