#!/tvbin/tivosh
# set_DC_key.tcl 1.0 - rc3105@dealdatabase.com/forum
# this restores a tivo DiskConfigurationKey from DC_key.xml
# run this from var with DC_key.xml present, reboot to use the new key

proc item_from_xml_line { line item } {
 set il [expr [string length $item] + 2]
 set sindex  [expr [string first "<$item>" $line] + $il]
 set sindex2 [expr [string first "</$item>" $line] - 1]
 set data [string range $line $sindex $sindex2]
 return $data
}


proc load_DC_keys { } {
set inf [open DC_key.xml r]
fconfigure $inf -translation binary
set xml [read $inf]
close $inf
set lines [split $xml \n]
#foreach line $lines { puts "$line" }
return [lindex $lines 1]
}


proc set_DC_key { DC_keys } {
puts "entering set_DC_key"
 set db [dbopen]
 set num_of_keys [llength $DC_keys] ; puts "$num_of_keys key values"
 RetryTransaction {
	set obj [db $db open "/State/Media"]
	set key [lindex $DC_keys 0]
	set keys [lrange $DC_keys 1 end]
	dbobj $obj set DiskConfiguration $key
	foreach key $keys {
		dbobj $obj add DiskConfiguration $key
#		puts [format "%04x" $key]
	}
 }
}


set dckeys [load_DC_keys]
set dckeys [item_from_xml_line $dckeys DiskConfiguration]
set_DC_key $dckeys
puts $dckeys
